library DrBob;
{$A-,B-,D-,F-,G-,H+,I-,K-,L-,N-,P-,Q-,R-,S+,T-,V-,W-,X+,Y-}
{$IFDEF WIN32}
{$R DRBOB32.RES}
{$ELSE}
{$R DRBOB16.RES}
{$ENDIF}
{$R *.DFM}
uses
{$IFDEF WIN32}
  ShareMem, Dialogs,
{$ENDIF}
  WinTypes, WinProcs, Forms, TBLabel, Controls, StdCtrls, ExtCtrls, Messages,
  Buttons, SysUtils,
  ExptIntf, ToolIntf, DllIntf,
  FileOpen,
  SysInfo,
  ResInfo,
  ProgManX,
  ProjInfo,
  DLLSkExp,
  CompExpt,
  MarcoBob,
  SplashEx,
  HcExpert,
  ResConv,
  ExpLoad, Classes;

Type
  TBSplash = class(TForm)
    Panel: TPanel;
    Image: TImage;
    Experts: TB3dLabel;
    Copyright: TLabel;
    Header: TB3dLabel;
    Label1: TLabel;
    procedure FormActivate(Sender: TObject);
    procedure Click(Sender: TObject);
  end {TBSplash};

  procedure TBSplash.FormActivate(Sender: TObject);
  begin
    Left := (GetSystemmetrics(SM_CXSCREEN) - Width) div 2;
    Top := (GetSystemmetrics(SM_CYSCREEN) div 3) - Height;
    if Top < 100 then Top := 100;
    if not ShareMem.Delphi then
    begin
      Header.Caption := 'Dr.Bob''s Collection C++Builder';
      Header.Left := Header.Left - 6
    end;
    if ShareMem.Delphi and (ShareMem.Version = 2) then Experts.Caption := 'Experts'
  end {FormActivate};

  procedure TBSplash.Click(Sender: TObject);
  begin
    ModalResult := mrOk
  end {Click};

Const
  Splash: TBSplash = nil;

  procedure Delay(MSec: LongInt);
  var
    Time: LongInt;
  begin
    Time := GetTickCount + MSec;
    while GetTickCount <= Time do Application.ProcessMessages
  end {Delay};

Type
  TStart = class(TIExpert)
  public
    function GetStyle: TExpertStyle; override;
    function GetIDString: string; override;
    function GetName: String; override;
  {$IFDEF WIN32}
    function GetAuthor: String; override;
  {$ENDIF}
    function GetMenuText: string; override;
    function GetState: TExpertState; override;
  end;

  function TStart.GetStyle: TExpertStyle;
  begin
    Result := esStandard
  end;

  function TStart.GetIDString: String;
  begin
    Result := 'DrBob.TStart'
  end;

  function TStart.GetName: String;
  begin
    Result := '-'
  end;

{$IFDEF WIN32}
  function TStart.GetAuthor: String;
  begin
    Result := 'Dr.Bob'
  end {GetAuthor};
{$ENDIF}

  function TStart.GetMenuText: String;
  begin
    Result := '-';
  end;

  function TStart.GetState: TExpertState;
  begin
    Result := [esEnabled]
  end;

Type
  TStop = class(TIExpert)
  public
    function GetStyle: TExpertStyle; override;
    function GetIDString: string; override;
    function GetName: String; override;
  {$IFDEF WIN32}
    function GetAuthor: String; override;
  {$ENDIF}
    function GetMenuText: string; override;
    function GetState: TExpertState; override;
  end;

  function TStop.GetStyle: TExpertStyle;
  begin
    Result := esStandard
  end;

  function TStop.GetIDString: String;
  begin
    Result := 'DrBob.TStop'
  end;

  function TStop.GetName: String;
  begin
    Result := '-'
  end;

{$IFDEF WIN32}
  function TStop.GetAuthor: String;
  begin
    Result := 'Dr.Bob'
  end {GetAuthor};
{$ENDIF}

  function TStop.GetMenuText: String;
  begin
    Result := '-';
  end;

  function TStop.GetState: TExpertState;
  begin
    Result := [esEnabled]
  end;

Type
  TDrBobExpert = class(TIExpert)
  public
    { Expert Style }
    function GetStyle: TExpertStyle; override;
    { Expert Strings }
    function GetIDString: string; override;
    function GetName: string; override;
  {$IFDEF WIN32}
    function GetAuthor: String; override;
  {$ENDIF}
    function GetMenuText: string; override;
    function GetState: TExpertState; override;
    { Launch the Expert }
    procedure Execute; override;
  end {TDrBobExpert};

  function TDrBobExpert.GetStyle: TExpertStyle;
  begin
    Result := esStandard
  end {GetStyle};

  function TDrBobExpert.GetIDString: String;
  begin
    try
      Result := 'DrBob.TDrBobExpert'
    except
      HandleException
    end
  end {GetIDString};

  function TDrBobExpert.GetName: String;
  begin
    Result := 'DrBob'
  end {GetName};

{$IFDEF WIN32}
  function TDrBobExpert.GetAuthor: String;
  begin
    Result := 'Dr.Bob'
  end {GetAuthor};
{$ENDIF}

  function TDrBobExpert.GetMenuText: String;
  begin
    if (ShareMem.Version = 2) and Delphi then
      Result := '&Dr.Bob''s Collection of Delphi 2.x Experts:'
    else
      if Delphi then
        Result := '&Dr.Bob''s Collection of Delphi 3 Wizards:'
      else
        Result := '&Dr.Bob''s Collection of C++Builder Wizards:'
  end {GetMenuText};

  function TDrBobExpert.GetState: TExpertState;
  begin
    Result := [esEnabled]
  end {GetState};

  procedure TDrBobExpert.Execute;
  begin
    with TBSplash.Create(Application) do
    begin
      ShowModal;
      Free
    end
  end {Execute};


  procedure DoneExpert; {$IFDEF BUGWIN32} stdcall; {$ELSE} export; {$ENDIF}
  begin
    SysInfo.DoneExpert;
    ResInfo.DoneExpert;
    ProjInfo.DoneExpert;
    ExpLoad.DoneExpert;
  end {DoneExpert};


  function InitExpert(Delphi: TIToolServices;
                      RegisterProc: TExpertRegisterProc;
                  var Terminate: TExpertTerminateProc): Boolean;
  {$IFDEF WIN32} stdcall; {$ELSE} export; {$ENDIF}
  begin
    ExptIntf.ToolServices := Delphi; { Save! }
    if ToolServices <> nil then
    begin
      Application.Handle := ToolServices.GetParentHandle;
    { Application.ShowHint := True; }
      if Assigned(IniFile) and
        (IniFile.ReadString('DrBob','Splash','') <> 'no') then
      begin
        Splash := TBSplash.Create(Application);
        Splash.Show;
        Splash.Update;
        Delay(IniFile.ReadInteger('DrBob','Delay',500));
        Splash.Update;
      end
    end;
    Terminate := DoneExpert;
    @ExpLoad.LibraryExpertProcedure := @RegisterProc; { for expert loader! }
    Result := LibraryExpertProcedure(TStart.Create);
    if ShareMem.Delphi then
    begin
      Result := Result AND LibraryExpertProcedure(THeadConvExpert.Create);
      Result := Result AND LibraryExpertProcedure(THeadConvProjectExpert.Create);
      Result := Result AND LibraryExpertProcedure(THeadConvFormExpert.Create)
    end;
    Result := Result AND LibraryExpertProcedure(TResConvExpert.Create);
    Result := Result AND LibraryExpertProcedure(TExpertLoader.Create);
    if ShareMem.Delphi then
    begin
      Result := Result AND LibraryExpertProcedure(TMarcoBobExpert.Create);
      Result := Result AND LibraryExpertProcedure(TMarcoBobFormExpert.Create);
      Result := Result AND LibraryExpertProcedure(TSplashExpert.Create);
      Result := Result AND LibraryExpertProcedure(TSplashFormExpert.Create);
      Result := Result AND LibraryExpertProcedure(TComponentExpert.Create);
      Result := Result AND LibraryExpertProcedure(TComponentProjectExpert.Create);
      Result := Result AND LibraryExpertProcedure(TDLLSourceExpert.Create);
      Result := Result AND LibraryExpertProcedure(TDLLSourceProjectExpert.Create)
    end;
    ProjectInfoExpert := TProjectInfoExpert.Create;
    Result := Result AND LibraryExpertProcedure(ProjectInfoExpert);
    Result := Result AND LibraryExpertProcedure(TProgManExpert.Create);
    Result := Result AND LibraryExpertProcedure(TResInfoExpert.Create);
    Result := Result AND LibraryExpertProcedure(TSysInfoExpert.Create);
    Result := Result AND LibraryExpertProcedure(TFileOpenExpert.Create);
    Result := Result AND LibraryExpertProcedure(TDrBobExpert.Create);
    {$IFNDEF WIN32}
    Result := Result AND LibraryExpertProcedure(TStop.Create);
    {$ENDIF};
    if Assigned(Splash) then Splash.Free;
    Splash := nil
  end {InitExpert};


  procedure UpdateProj; {$IFDEF WIN32} stdcall; {$ELSE} export; {$ENDIF}
  begin
    try
      if Assigned(ProjectInfoExpert) then
        ProjectInfoExpert.Execute
    except
      HandleException
    end
  end {UpdateProj};


exports
  InitExpert name 'INITEXPERT0016', { Delphi 1.x & 2.x }
  InitExpert name 'INITEXPERT0017', { Delphi 3 }
  UpdateProj index 32;


begin
{$IFNDEF WIN32}
  { the following statement causes Delphi 2 to give an AV at closedown! }
  Application.HelpFile := ChangeFileExt(ParamStr(0),'.HLP')
{$ENDIF}
end.
